###############################################################################
# Launching Script for EaSynth ForeUI in UNIX/Linux/MacOSX platform
###############################################################################

LAUNCH_DIR=`dirname $0`

cd $LAUNCH_DIR

CLASSPATH=$LAUNCH_DIR

for h in $LAUNCH_DIR/lib/*.jar
do
  if [ -f "$h" ] ; then
    CLASSPATH="$h:$CLASSPATH"
  fi
done

SYSTEMNAME=$(uname | tr [a-z] [A-Z]) 
if [ "$SYSTEMNAME" = "DARWIN" ]
then
	JAVA_PATH="java -Dcom.apple.macos.useScreenMenuBar=true -Xdock:name=\"ForeUI\" -Xdock:icon=\"$LAUNCH_DIR/conf/ForeUI.icns\""
else
	JAVA_PATH="${JAVA_HOME}/bin/java"
fi

eval $JAVA_PATH -Xms100m -Xmx300m -Duser.language=en -cp $CLASSPATH com.easynth.foreui.MainApp $*