function Spinner_onStateChanged(id, state) {
	var editor = document.getElementById(id + "_Editor");
	if (editor != null) {
		var postfix = getPostfixForState(state);
		editor.className = id + "_Editor" + postfix;
		if (typeof(editor.disabled) != 'undefined') {
			editor.disabled = ((state & 64) > 0);
		}
	}
}

function Spinner_getValue(id) {
	var editor = document.getElementById(id + "_Editor");
	if (editor != null) {
		var tmpVal = parseInt(editor.value, 10);
		if ("" + tmpVal == editor.value) {
			return tmpVal;
		} else {
			return editor.value;
		}
	}
	return "";
}

function Spinner_setValue(id, value) {
	var editor = document.getElementById(id + "_Editor");
	if (editor != null) {
		editor.value = value;
	}
	return "";
}

function Spinner_Up(id) {
	var editor = document.getElementById(id + "_Editor");
	if (editor != null) {
		if (!isElementDisabled(editor)) {
			var valueIndex = parseInt(editor.getAttribute("valueIndex"), 10);
			if (valueIndex > 0) {
				var values = editor.getAttribute("values").split("\n");
				valueIndex -= 1;
				editor.value = values[valueIndex];
				editor.setAttribute("valueIndex", valueIndex);
			}
		}
	}
}

function Spinner_Down(id) {
	var editor = document.getElementById(id + "_Editor");
	if (editor != null) {
		if (!isElementDisabled(editor)) {
			var values = editor.getAttribute("values").split("\n");
			var valueIndex = parseInt(editor.getAttribute("valueIndex"), 10);
			if (valueIndex < values.length - 1) {
				valueIndex += 1;
				editor.value = values[valueIndex];
				editor.setAttribute("valueIndex", valueIndex);
			}
		}
	}
}
